<template>
  <div class="d-flex flex-column flex-grow-0 mt-4">
    <h2>Data de previsão</h2>
    <div>
      <date-picker
       v-model="referenceTime"
       :inline="true"
       :lang="lang()"
       :disabled-date="archiveRange"/>
    </div>
  </div>
</template>

<script>
import moment from 'moment'
import DatePicker from 'vue2-datepicker'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import { SET_WORKSPACE_REFERENCE_TIME } from '@/workspace/store/mutations'

export default {
  name: 'referencetimepicker',

  mixins: [
    WorkspaceGetter,
  ],

  computed: {
    referenceTime: {
      get() {
        return moment.unix(this.$store.getters.workspaceReferenceTime(this.workspaceId)).toDate()
      },

      set(value) {
        this.$store.commit(SET_WORKSPACE_REFERENCE_TIME, {
          workspaceId: this.workspaceId,
          referenceTime: moment(value).unix()
        })
      },
    },
  },

  methods: {
    lang() {
      return {
        lang: {
          formatLocale: {
            months: [
              'Janeiro',
              'Fevereiro',
              'Março',
              'Abril',
              'Maio',
              'Junho',
              'Julho',
              'Agosto',
              'Setembro',
              'Outubro',
              'Novembro',
              'Dezembro'
            ],
            weekdaysShort: ['Dom', 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab'],
            weekdaysMin: ['Do', '2º', '3ª', '4ª', '5ª', '6ª', 'Sa'],
          },
        },
      }
    },

    archiveRange(date) {
      let today = moment.utc()
      return date > today.toDate() || date < today.clone().subtract(220, 'days').toDate()
    },
  },

  components: {
    DatePicker,
  },
}
</script>
